# {
#   "tag": {
#     "with": [ "" ]
#   }
# }
module Anschel
  class Filter
    def tag conf, stats, log
      tags = conf.delete :with

      raise 'Missing required "with" for "tag" filter' if tags.nil?

      tags = tags.is_a?(Array) ? tags : [ tags ]

      stats.create 'filter-tag'

      log.info event: 'filter-compiled', kind: 'tag', with: tags



      lambda do |event|
        event[:tags] ||= []
        event[:tags]  += tags
        event[:tags].uniq!
        stats.inc 'filter-tag'
        filtered event, conf
      end

    end
  end
end