require 'thread'

require_relative 'base'


module Anschel
  class Output
    class Device < Base
      def initialize config, stats, log
        path   = config.delete(:path) || '/dev/stdout'
        qsize  = config.delete(:queue_size) || 2000
        @queue = SizedQueue.new qsize

        @thread = Thread.new do
          File.open(path, 'w') do |f|
            loop do
              f.puts @queue.shift
              f.flush
              stats.inc 'output'
            end
          end
        end
      end
    end
  end
end